<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <h2 class="text-center pb-3">Danh sách đơn hàng</h2>
        <table class="table text-center table-striped" id="table-order">
            <thead>
                <tr>
                    <th scope="col">Order Code</th>
                    <th scope="col">Kích cỡ combo</th>
                    <th scope="col">Loại pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                    <th scope="col">Xóa</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
        const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        const gEND_ROW_TABLE = -1;
        // hằng số số thứ tự các cột
        const gCOLUMN_ORDER_CODE = 0;
        const gCOLUMN_SIZE = 1;
        const gCOLUMN_PIZZA_TYPE = 2;
        const gCOLUMN_DRINK = 3;
        const gCOLUMN_CASH = 4;
        const gCOLUMN_CUSTOMER_NAME = 5;
        const gCOLUMN_CUSTOMER_NUMBER = 6;
        const gCOLUMN_STATUS = 7;
        const gCOLUMN_DETAIL = 8;
        const gCOLUMN_DELETE = 9;
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }

        function onBtnChiTietClick(paramDetailButton) {
            // thu thập dữ liệu
            var vId = paramDetailButton.dataset.id;
            var vOrderCode = paramDetailButton.dataset.ordercode;
            // gọi và truyền data qua form Detail
            const vDETAIL_FORM_URL = "orderDetail.html"
            var vUrlSiteToOpen = vDETAIL_FORM_URL +
                "?id=" + vId +
                "&orderCode=" + vOrderCode;
            window.location.href = vUrlSiteToOpen;
        }

        function onBtnXoaClick(paramDeleteButton) {
            var vDeleteConfirm = confirm("Bạn có chắc chắn muốn xóa đơn hàng này?");
            if (vDeleteConfirm) {
                // thu thập dữ liệu
                var vId = paramDeleteButton.dataset.id;
                var vXmlHttpDeleteOrder = new XMLHttpRequest();
                callApiDeleteOrder(vId, vXmlHttpDeleteOrder);
                thongBaoDeleteOrder(vId, vXmlHttpDeleteOrder);
            }
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
            /**
           * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
           */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            paramXMLHttpGetAllOrders.open("GET", gBASE_URL, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            console.log(paramXMLHttpAllOrder.responseText);
            var vAllOrderRespone = JSON.parse(paramXMLHttpAllOrder.responseText);
            var vTable = document.getElementById("table-order");
            var vTableBody = vTable.getElementsByTagName("tbody")[0]; //lấy tagname tbody vì nếu trỏ vào table cũng được nhưng nó sẽ vào thẻ thead
            vTableBody.innerHTML = "";

            for (var bIndex = 0; bIndex < vAllOrderRespone.length; bIndex++) {
                var vOrder = vAllOrderRespone[bIndex];
                // tạo dòng mới cho bẳng và ghi vào các giá trị 
                var vRow = vTableBody.insertRow(gEND_ROW_TABLE);
                var vCellOrderCode = vRow.insertCell(gCOLUMN_ORDER_CODE);
                var vCellSize = vRow.insertCell(gCOLUMN_SIZE);
                var vCellPizzaType = vRow.insertCell(gCOLUMN_PIZZA_TYPE);
                var vCellDrink = vRow.insertCell(gCOLUMN_DRINK);
                var vCellCash = vRow.insertCell(gCOLUMN_CASH);
                var vCellCustomerName = vRow.insertCell(gCOLUMN_CUSTOMER_NAME);
                var vCellCustomerNumber = vRow.insertCell(gCOLUMN_CUSTOMER_NUMBER);
                var vCellStatus = vRow.insertCell(gCOLUMN_STATUS);
                var vCellDetail = vRow.insertCell(gCOLUMN_DETAIL);
                var vCellDelete = vRow.insertCell(gCOLUMN_DELETE);

                vCellOrderCode.innerHTML = vOrder.orderCode;
                vCellSize.innerHTML = vOrder.kichCo;
                vCellPizzaType.innerHTML = vOrder.loaiPizza;
                vCellDrink.innerHTML = vOrder.idLoaiNuocUong;
                vCellCash.innerHTML = vOrder.thanhTien;
                vCellCustomerName.innerHTML = vOrder.hoTen;
                vCellCustomerNumber.innerHTML = vOrder.soDienThoai;
                vCellStatus.innerHTML = vOrder.trangThai;
                //xử lí nút chi tiết
                var vButtonDetail = document.createElement("button");
                vButtonDetail.innerHTML = "Chi tiết";
                vButtonDetail.className = 'btn btn-info info-order'; //đặt info-order để truy xuất
                vButtonDetail.setAttribute("data-id", vOrder.id);
                vButtonDetail.setAttribute("data-ordercode", vOrder.orderCode);
                vButtonDetail.setAttribute("onclick", 'onBtnChiTietClick(this)');
                vCellDetail.appendChild(vButtonDetail);
                //xử lí nút xóa
                var vButtonDelete = document.createElement("button");
                vButtonDelete.innerHTML = "Xoá";
                vButtonDelete.className = 'btn btn-danger delete-order'; //đặt delete-order để truy xuất
                vButtonDelete.setAttribute("data-id", vOrder.id);
                vButtonDelete.setAttribute("onclick", 'onBtnXoaClick(this)');
                vCellDelete.appendChild(vButtonDelete);
            }
        }

        function callApiDeleteOrder(paramOrderId, paramXmlHttpDeleteOrder) {
            paramXmlHttpDeleteOrder.open("DELETE", gBASE_URL + "/" + paramOrderId, true);
            paramXmlHttpDeleteOrder.send();
        }

        function thongBaoDeleteOrder(paramOrderId, paramXmlHttpDeleteOrder) {
            paramXmlHttpDeleteOrder.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK)
                    if (this.status == gREQUEST_DELETE_SUCCESS) {
                        console.log("Đã xóa order " + paramOrderId);
                        alert("Delete order " + paramOrderId + " thành công!");
                        getAllOrders();
                    }
                    else {
                        alert("Delete order " + paramOrderId + " thất bại!");
                        getAllOrders();
                    }
            }
        }
    </script>
</body>

</html>